
/*
 * This is the header for the RS232 emulation. 
 *
 * The RS232 emulation captures the bytes sent to the RS232 interfaces
 * available (currently only ACIA 6551, later UART 16550A, std C64, 
 * and Daniel Dallmanns fast RS232 with 9600 Baud). 
 * The characters captured are displayed in a special terminal window.
 * Characters typed in the terminal window are sent back to the 
 * chip emulations. 
 */

/* initializes all RS232 stuff */
extern void rs232_reset(void);

/* opens a rs232 window, returns handle to give to functions below. */
extern int rs232_open(void);

/* closes the rs232 window again */
extern void rs232_close(int fd);
 
/* sends a byte to the RS232 line */
extern int rs232_putc(int fd, BYTE b);

/* gets a byte to the RS232 line, returns !=1 if byte received, byte in *b. */
extern int rs232_getc(int fd, BYTE *b);

